
#include <stdio.h> // fuer printf()
#include <stdlib.h> //fuer rand(), srand()
#include <time.h> //fuer time()


int potrek (int x, int n)
{
    if (x < 0 || n < 0) return -1;
    if (n == 0) return 1;
    return x * potrek(x, n-1);
}

int main()
{
    // Bestimme Minimum in array a[]
    int a[9] = { 2, 5, 7, 1, 9, 8, 6, 3, 4 };
    int i;
    int min = a[0];
    for (i=1; i < 9; i++)
        if (a[i] < min) min = a[i];
    printf("min = %d\n\n", min);
    
    /////////////////////////////////
    
    //Berechne Summe der geraden Zahlen in obigem array a[]
    int sum = 0;
    for (i=0; i < 9; i++) {
        if (a[i] % 2 == 0) {
            sum = sum + a[i];
        }
    }
    printf("sum = %d\n\n", sum);
    
    /////////////////////////////////
    
    //Berechne x^n iterativ fuer x = 3, n=4
    int x = 3, n = 4;
    int pot = 1;
    for (i=0; i < n; i++) {
        pot = x * pot;
    }
    printf("pot = %d\n\n", pot);
    
    /////////////////////////////////

    //Berechne x^n mit oben definierter rek Fkt potrek fuer x = 3, n = 4
    //int x = 3, n = 4;  Werte von x, n oben schon festgelegt
    
    printf("potrek = %d\n\n", potrek(x,n));
    
    /////////////////////////////////
    
    //Collatz-Problem, aka  (3n+1)-Vermutung
    srand( (unsigned int) time(NULL));
    int c = 1 + rand() % 1000;
    printf("Startwert: %d\n", c);
    while (c>1)
    {
        if (c % 2 == 0) c = c/2;
        else c = 3*c +1;
        printf("%d\n", c);
    }
    printf("Wie in allen bisher untersuchten  Faellen sind wir bei 1 angekommen\n\n");
    
    //////////////////////////////////
    
    //Berechne Wurzel aus 2 nach Newtonscher Formel
    float w =1;
    float eps = 0.000001;
    while ( (w*w - 2 )*( w*w - 2) > eps*eps ) // Ersatzkonstr. fuer | w^2 - 2 | > eps
    {
        w= (w + 2/w)/2;
    }
    printf("Wurzel aus 2: %f\n", w);

}





